private import example_extern;



/*
 * Created by the power of SWIG!
 */


class Shape {

protected void* swig_impl;
protected bool  swig_own_ptr;
protected this(void* ptr, bool own) {
    swig_impl = ptr;
    swig_own_ptr = own;
}

protected void swig_destroy()
out {
    assert(swig_impl === null);
}
body {
    if (swig_own_ptr && swig_impl !== null) {
        SwigWrap_delete_Shape(swig_impl);
    }
    swig_impl = null;
}

~this() {
    swig_destroy();
    // HACK: The current DMD implementation will not enforce the out contract on
    // swig_destroy if it is overridden
    assert(swig_impl === null);
}

void x(double x) {
    void* self;
    double arg2;
    
    self = swig_impl;
    arg2 = cast(double)x; 
    SwigWrap_Shape_x_set(self, arg2); 
}

double x() {
    void* self;
    double result;
    
    self = swig_impl;
    result = SwigWrap_Shape_x_get(self); 
    return result;
}

void y(double y) {
    void* self;
    double arg2;
    
    self = swig_impl;
    arg2 = cast(double)y; 
    SwigWrap_Shape_y_set(self, arg2); 
}

double y() {
    void* self;
    double result;
    
    self = swig_impl;
    result = SwigWrap_Shape_y_get(self); 
    return result;
}

void move(double dx, double dy) {
    void* self;
    double arg2;
    double arg3;
    
    self = swig_impl;
    arg2 = cast(double)dx; 
    arg3 = cast(double)dy; 
    SwigWrap_Shape_move(self, arg2, arg3); 
}

double area() {
    void* self;
    double result;
    
    self = swig_impl;
    result = SwigWrap_Shape_area(self); 
    return result;
}

double perimeter() {
    void* self;
    double result;
    
    self = swig_impl;
    result = SwigWrap_Shape_perimeter(self); 
    return result;
}

void* asShape() {
    void* self;
    void* result;
    
    self = swig_impl;
    return result;
}

static void nshapes(int value) {
    int arg1;
    
    arg1 = cast(int)value; 
    SwigWrap_Shape_nshapes_set(arg1); 
}

static int nshapes() {
    int result;
    
    result = SwigWrap_Shape_nshapes_get(); 
    return result;
}

} // end class Shape

class Circle : Shape {

protected this(void* ptr, bool own) {
    super(ptr, own);
}

this(double arg1) {
    this(SwigWrap_new_Circle(arg1), true);
}

double area() {
    void* self;
    double result;
    
    self = swig_impl;
    result = SwigWrap_Circle_area(self); 
    return result;
}

double perimeter() {
    void* self;
    double result;
    
    self = swig_impl;
    result = SwigWrap_Circle_perimeter(self); 
    return result;
}

    protected override void swig_destroy() {
        if (swig_own_ptr && swig_impl !== null) {
            SwigWrap_delete_Circle(swig_impl);
        }
        swig_impl = null;
    }

} // end class Circle

class Square : Shape {

protected this(void* ptr, bool own) {
    super(ptr, own);
}

this(double arg1) {
    this(SwigWrap_new_Square(arg1), true);
}

double area() {
    void* self;
    double result;
    
    self = swig_impl;
    result = SwigWrap_Square_area(self); 
    return result;
}

double perimeter() {
    void* self;
    double result;
    
    self = swig_impl;
    result = SwigWrap_Square_perimeter(self); 
    return result;
}

    protected override void swig_destroy() {
        if (swig_own_ptr && swig_impl !== null) {
            SwigWrap_delete_Square(swig_impl);
        }
        swig_impl = null;
    }

} // end class Square

class TestClass {

protected void* swig_impl;
protected bool  swig_own_ptr;
protected this(void* ptr, bool own) {
    swig_impl = ptr;
    swig_own_ptr = own;
}

uint explode() {
    void* self;
    uint result;
    
    self = swig_impl;
    result = SwigWrap_TestClass_explode__SWIG_0(self); 
    return result;
}

void explode(long ll) {
    void* self;
    long arg2;
    
    self = swig_impl;
    arg2 = cast(long)ll; 
    SwigWrap_TestClass_explode__SWIG_1(self, arg2); 
}

char* explode(real ld) {
    void* self;
    real arg2;
    char* result;
    
    self = swig_impl;
    arg2 = cast(real)ld; 
    result = SwigWrap_TestClass_explode__SWIG_2(self, arg2); 
    return result;
}

real explode(int a, int b, int c, int d) {
    void* self;
    int arg2;
    int arg3;
    int arg4;
    int arg5;
    real result;
    
    self = swig_impl;
    arg2 = cast(int)a; 
    arg3 = cast(int)b; 
    arg4 = cast(int)c; 
    arg5 = cast(int)d; 
    result = SwigWrap_TestClass_explode__SWIG_3(self, arg2, arg3, arg4, arg5); 
    return result;
}

this() {
    this(SwigWrap_new_TestClass(), true);
}

protected void swig_destroy()
out {
    assert(swig_impl === null);
}
body {
    if (swig_own_ptr && swig_impl !== null) {
        SwigWrap_delete_TestClass(swig_impl);
    }
    swig_impl = null;
}

~this() {
    swig_destroy();
    // HACK: The current DMD implementation will not enforce the out contract on
    // swig_destroy if it is overridden
    assert(swig_impl === null);
}

} // end class TestClass

